<?php
class PaykeeperPaymentModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::initContent()
     */

    private $product_cart = array(); //fz54 cart
    private $order_total = 0;
    private $shipping_price = 0;
    protected $templateName = 'module:paykeeper/views/templates/hook/payment.tpl';

    public function initContent()
    {
        parent::initContent();

        //Prestashop order cart
        $order_cart = $this->context->cart;

        //if (!$this->module->checkCurrency($cart)) {
            //Tools::redirect('index.php?controller=order');
        //}

        $customer = new Customer((int)($order_cart->id_customer));
        $address  = new Address((int)($order_cart->id_address_invoice));

        $this->setOrderTotal($order_cart->getOrderTotal());
        $clientid     = $customer->firstname . " " . $customer->lastname;
        $orderid      = $order_cart->id;
        $client_phone = $address->phone;
        $client_email = $customer->email;
        $service_name = $this->context->customer->secure_key;
        $secret       = Configuration::get('PAYKEEPER_SECRET', null);
        $url          = Configuration::get('PAYKEEPER_URL', null);

        //GENERATE FZ54 CART
        $cart_sum = 0;
        $tax = "none";
        $tax_sum = 0;
        $tax_value = 0;

        $cart_data = $order_cart->getProducts();

        foreach ($cart_data as $product) {
            $name = $product["name"];
            $price = number_format($product['price_wt'], 2, ".", "");
            $quantity = $product['quantity'];
            $sum = number_format($price*$quantity, 2, ".", "");
            $cart_sum += $sum;

            if ( (int)$product["rate"] != 0) {
                switch((int)$product["rate"]) {
                    case 10:
                        $tax = "vat10";
                        $tax_sum = round((float)(($sum/110)*10), 2);
                        break;
                    case 18:
                        $tax = "vat18";
                        $tax_sum = round((float)(($sum/118)*18), 2);
                        break;
                }
            }

            $this->updateProductCart($name, $price, $quantity, $sum, $tax, $tax_sum);

            $tax = "none";
            $tax_sum = 0;
            $tax_value = 0;
        }

        //add shipping service
        $carrier = new Carrier((int)$order_cart->id_carrier, $order_cart->id_lang);
        $this->setShippingPrice($order_cart->getTotalShippingCost());
        $shipping_name = $carrier->name;
        $shipping_tax = round((float)(($this->getShippingPrice()/118)*18), 2);

        $this->updateProductCart($shipping_name, $this->getShippingPrice(), 1, $this->getShippingPrice(), "vat18", $shipping_tax);

        //set discounts
        $cart_sum = $this->setDiscounts($order_cart, $cart_sum);
        
        //handle possible precision problem
        $is_correct_precision = $this->isCorrectPrecision($cart_sum);
        
        $product_cart_encoded = json_encode($this->product_cart);

        $to_hash = $this->getOrderTotal()   .
                   $clientid                .
                   $orderid                 .
                   $service_name            .
                   $client_email            .
                   $client_phone            .
                   $secret;
        $sign = hash ('sha256', $to_hash);


//        $order_sum    = $order_cart->getOrderTotal();
//        $clientid     = $customer->firstname . " " . $customer->lastname;
//        $orderid      = $order_cart->id;
//        $client_phone = $address->phone;
//        $client_email = $customer->email;
//        $service_name = $this->context->customer->secure_key;
//        $secret       = Configuration::get('PAYKEEPER_SECRET', null);
//        $url          = Configuration::get('PAYKEEPER_URL', null);
//
//        //GENERATE FZ54 CART
//        $cart = array();
//        $cart_sum = 0;
//        $tax = "none";
//        $tax_sum = 0;
//        $tax_value = 0;
//
//        $cart_data = $order_cart->getProducts();
//
//        foreach ($cart_data as $product) {
//            $price = number_format($product['price_wt'], 2, ".", "");
//            $quantity = $product['quantity'];
//            $sum = number_format($price*$quantity, 2, ".", "");
//            $cart_sum += $sum;
//
//            if ( (int)$product["rate"] != 0) {
//
//                switch((int)$product["rate"]) {
//
//                    case 10:
//                        $tax = "vat10";
//                        $tax_sum = round((float)(($sum/110)*10), 2);
//                        break;
//
//                    case 18:
//                        $tax = "vat18";
//                        $tax_sum = round((float)(($sum/118)*18), 2);
//                        break;
//                }
//            }
//            $name = $product["name"];
//            $name = str_replace("\n ", "", $name);
//            $name = str_replace("\r ", "", $name);
//            $name = str_replace(" ", "&nbsp;", $name);
//            $cart[] = array(
//                "name" => htmlspecialchars($name),
//                "price" => $price,
//                "quantity" => $quantity,
//                "sum" => $sum,
//                "tax" => $tax,
//                "tax_sum" => number_format($tax_sum, 2, ".", "")
//            );
//            $tax = "none";
//            $tax_sum = 0;
//            $tax_value = 0;
//        }
//        //add shipping service
//        $carrier = new Carrier((int)$order_cart->id_carrier, $order_cart->id_lang);
//        //$shipping_price = $order_cart->getCarrierCost($order_cart->id_carrier);
//        $shipping_price = $order_cart->getTotalShippingCost();
//        $shipping_name = $carrier->name;
//        $shipping_name = str_replace("\n ", "", $shipping_name);
//        $shipping_name = str_replace("\r ", "", $shipping_name);
//        $shipping_name = str_replace(" ", "&nbsp;", $shipping_name);
//        $cart[] = array(
//            "name" => htmlspecialchars($shipping_name),
//            "price" => number_format($shipping_price, 2, ".", ""),
//            "quantity" => 1,
//            "sum" => number_format($shipping_price, 2, ".", ""),
//            "tax" => 'vat18',
//            "tax_sum" => round((float)(($shipping_price/118)*18), 2)
//        );
//
//        //handle of using discount coupons
//        if (array_key_exists("coupon", $this->session->data)) {
//            $order_sum = $data['sum'] - $shipping_price;
//            if ($cart_sum > $order_sum) {
//                $percent = ($cart_sum - $order_sum) / ($cart_sum/100);
//                $cart_sum = 0;
//                for ($pos=0; $pos<count($cart)-1; $pos++) {
//                    $price_diff = $cart[$pos]['price']/100*$percent;
//                    $cart[$pos]['price'] -= $price_diff;
//                    $cart[$pos]['price'] = number_format($cart[$pos]['price'], 2, ".", "");
//                    $cart[$pos]['sum'] = $cart[$pos]['price']*$cart[$pos]['quantity'];
//                    $cart[$pos]['sum'] = number_format($cart[$pos]['sum'], 2, ".", "");
//                    $cart_sum += $cart[$pos]['sum'];
//                }
//            }
//        }

//        //handle possible precision problem
//        $precision_error = False;
//        $total_sum = number_format($order_sum, 2, ".", "");
//        //add shipping sum to cart sum
//        if ($shipping_price > 0)
//            $cart_sum = $cart_sum+$cart[count($cart)-1]['sum'];
//        //DEBUG
//        //echo "total: " . $total_sum . " - cart: " . $cart_sum;
//        $diff_sum = $cart_sum - $total_sum;
//        if (abs($diff_sum) <= 0.019) {
//            $order_sum = number_format($total_sum+$diff_sum, 2, ".", "");
//        }
//        else $precision_error = True;
//
//        $cart = json_encode($cart);
//
//        $to_hash = $order_sum    .
//                   $clientid     .
//                   $orderid      .
//                   $service_name .
//                   $client_email .
//                   $client_phone .
//                   $secret;
//        $sign = hash ('sha256', $to_hash);

        $this->context->smarty->assign(array(
            'sum'             => $this->getOrderTotal(),
            'clientid'        => $clientid,
            'orderid'         => $orderid,
            'client_phone'    => $client_phone,
            'client_email'    => $client_email,
            'service_name'    => $service_name,
            'cart'            => $product_cart_encoded,
            'sign'            => $sign,
            'url'             => $url,
            'precision_error' => $is_correct_precision,
        ));

        $this->setTemplate($this->templateName);
    }

    public function hookDisplayPaymentReturn()
    {
        /* Place your code here. */
        echo "Thank you for you order!";
    }

    private function updateProductCart($name="", $price=0, $quantity=0, $sum=0, $tax="none", $tax_value=0)
    {
        //update fz54 cart
        $name = str_replace("\n ", "", $name);
        $name = str_replace("\r ", "", $name);
        $name = str_replace(" ", "&nbsp;", $name);
        $name = preg_replace('/"{1,}/','\'',$name);
        $this->product_cart[] = array(
            "name" => htmlspecialchars($name),
            "price" => $price,
            "quantity" => $quantity,
            "sum" => $sum,
            "tax" => $tax,
            "tax_sum" => number_format($tax_value, 2, ".", "")
        );
    }

    private function getProductCart()
    {
        return $this->product_cart;
    }

    private function setDiscounts($order_cart, $cart_sum)
    {
        //set discounts
        $product_cart_sum = $cart_sum;
        if (!empty($order_cart->getDiscounts())) {
            $order_sum = $this->getOrderTotal() - $this->getShippingPrice();
            if ($product_cart_sum > $order_sum) {
                $percent = ($product_cart_sum - $order_sum) / ($product_cart_sum/100);
                $product_cart_sum = 0;
                for ($pos=0; $pos<count($this->product_cart)-1; $pos++) {
                    $price_diff = $this->product_cart[$pos]['price']/100*$percent;
                    $this->product_cart[$pos]['price'] -= $price_diff;
                    $this->product_cart[$pos]['price'] = number_format($this->product_cart[$pos]['price'], 2, ".", "");
                    $this->product_cart[$pos]['sum'] = $this->product_cart[$pos]['price']*$this->product_cart[$pos]['quantity'];
                    $this->product_cart[$pos]['sum'] = number_format($this->product_cart[$pos]['sum'], 2, ".", "");
                    $product_cart_sum += $this->product_cart[$pos]['sum'];
                    //recalculate taxes
                    switch($this->product_cart[$pos]['tax']) {
                        case "vat10":
                            $this->product_cart[$pos]['tax_sum'] = round((float)(($this->product_cart[$pos]['sum']/110)*10), 2);
                            break;
                        case "vat18":
                            $this->product_cart[$pos]['tax_sum'] = round((float)(($this->product_cart[$pos]['sum']/118)*18), 2);
                            break;
                    }
                }
            }
        }
        return $product_cart_sum;
    }

    private function isCorrectPrecision($cart_sum)
    {
        //handle possible precision problem
        $product_cart_sum = $cart_sum;
        $total_sum = number_format($this->getOrderTotal(), 2, ".", "");
        //add shipping sum to cart sum
        if ($this->getShippingPrice() > 0)
            $product_cart_sum += $this->product_cart[count($this->product_cart)-1]['sum'];
        //DEBUG
        //echo "total: " . $total_sum . " - cart: " . $cart_sum;
        $diff_sum = $product_cart_sum - $total_sum;
        if (abs($diff_sum) <= 0.019) {
            $this->setOrderTotal(number_format($total_sum+$diff_sum, 2, ".", ""));
            return True;
        }
        else return False;
    }

    private function setOrderTotal($value)
    {
        $this->order_total = $value;
    }

    private function getOrderTotal()
    {
        return $this->order_total;
    }

    private function setShippingPrice($value)
    {
        $this->shipping_price = $value;
    }

    private function getShippingPrice()
    {
        return $this->shipping_price;
    }
}
